package cn.estsh.i3plus.ext.mes.pcn.api.busi.jx;

import cn.estsh.i3plus.ext.mes.pcn.pojo.bean.MesOutPutStatisticsTimeSegment;
import io.swagger.annotations.ApiOperation;

import java.util.List;

/**
 * @Author: wangjie
 * @CreateDate: 2021/01/18 11:22 上午
 * @Description:
 **/
public interface IJxOutPutStatisticsTimeSegmentService {

    /**
     * 根据工单,作业时间,分时代码查询分时产量统计信息
     * @param organizeCode 组织代码
     * @param workOrderNo 工单
     * @param workTime 作业时间
     * @param shiftCode 班次代码
     * @param timeSegmentCode 分时代码
     * @return 分时产量统计信息
     */
    @ApiOperation(value = "根据工单,作业时间,班次代码,分时代码查询分时产量统计信息", notes = "根据工单,作业时间,班次代码,分时代码查询分时产量统计信息")
    List<MesOutPutStatisticsTimeSegment> getOutPutStatisticsTimeSegmentByOrderAndTsCode(String organizeCode, String workOrderNo, String workTime, String shiftCode, String timeSegmentCode);

}
